 clear
close all

CenterFrequency=546.775e6;% poprawka na nosna
ile_przebiegow_zapisac=10;%


czas_przebiegu_s=1;%w jednym wektorze
% if ~exist('connectedRadios','var') || strcmp(connectedRadios.Platform,'')
connectedRadios = findsdru;
% end
if strncmp(connectedRadios(1).Status, 'Success', 7)
    radioFound = true;
    platform = connectedRadios(1).Platform;
    switch connectedRadios(1).Platform
        case {'B200','B210'}
            address = connectedRadios(1).SerialNum;
        otherwise
            error('USRP B200/210 not found. Check connection. Restart script')
    end
else
    error('USRP B200/210 not found. Check connection. Restart script')
end


MasterClockRate=5e6;%The clock rate can be set to any value between 5 MHz and 61.44 MHz (or 30.72 MHz for dual-channel mode).
%Note that rates above 56 MHz are possible, but not recommended.
radio = comm.SDRuReceiver( ...
    'Platform', platform, ...
    'SerialNum', address,...
    'ChannelMapping',1, ...%RF A or B
    'MasterClockRate', MasterClockRate,'EnableBurstMode',false,'TransportDataType','int16');
radio.DecimationFactor = 512;
radio.LocalOscillatorOffset=MasterClockRate/radio.DecimationFactor/2;

radioinfo=radio.info;
max_gain=radioinfo.MaximumGain;
min_gain=radioinfo.MinimumGain;
N=512;% liczba podnosnych


radio.CenterFrequency  = CenterFrequency;
gain=round((min_gain+max_gain)/2);% przykladowo
radio.Gain = gain;% max 76 dB for B210
% czas_obserwacji_s=1;%w jednym wektorze
probek_na_raz=round(czas_przebiegu_s*MasterClockRate/radio.DecimationFactor);
radio.SamplesPerFrame =probek_na_raz;
radio.OutputDataType = 'double';
% mozna sprawdzic parametry przez info(radio) - Odbior przez wejscie RX2
freq=linspace(-MasterClockRate/radio.DecimationFactor/2,MasterClockRate/radio.DecimationFactor/2,N);
[x,no_samples,~,timestamps]=step(radio);
if no_samples<probek_na_raz
    warning('pobrano z USRP mniej probek')
end
% [x, metadata,timestamps] = capture(radio,probek_na_raz,'Samples');

alfa=0.5;% PARAMETR USREDNIANIA WIDMA
chwilowa=abs(fft(x(1:N))).^2;
srednia=chwilowa;
[~,integer_f_off]=max(srednia);
integer_f_off=mod(integer_f_off-1+N/2,N)-N/2% w zakresie od -N/2 do N/2-1
%%
decymacja=20;% co ktora probke wyswietlic
fig=figure;
subplot('Position',[0.1 0.65 0.85 0.28])
wykres_t=plot([0:decymacja:length(x)-1]*1/(MasterClockRate/radio.DecimationFactor),abs(transpose(x(1:decymacja:end)).*exp(-1j*2*pi*integer_f_off/N*[1:decymacja:length(x)])));
grid on
xlabel('time (s)')
ylabel('amplitude')
subplot('Position',[0.1 0.25 0.85 0.30])
wykres_f=plot(freq/10^3+0*radio.CenterFrequency,fftshift(10*log10(srednia)));
ylim([-50 30])
grid on
xlim([freq(1)/10^3+0*radio.CenterFrequency freq(end)/10^3+0*radio.CenterFrequency])
xlabel('frequency offset (kHz)')
ylabel('Normalized power (dB)')
%kontrola=subplot('Position',[0 0 1 0.1])
gain_slider = uicontrol('Parent',fig,'Style','slider','Units' ,'Normalized' ,  'Position',[0.05 0.01 0.3 0.1],...
    'value',gain, 'min',min_gain, 'max',max_gain);
gain_text=annotation(fig,'textbox','String',['Gain (dB):' num2str(gain)],'units','normalized', 'Position', [0.05 0.07 0.3 0.1],'EdgeColor','none');

freq_box = uicontrol('Parent',fig,'Style','edit','Units' ,'Normalized' ,  'Position',[0.6 0.01 0.37 0.1]);
freq_text=annotation(fig,'textbox','String',['Center. freq. (Hz):' num2str(CenterFrequency)],'units','normalized', 'Position', [0.6 0.07 0.37 0.1],'EdgeColor','none');

record_button = uicontrol('Parent',fig,'Style','togglebutton','String','Record','Units' ,'Normalized' ,  'Position',[0.37 0.01 0.2 0.1]);
record_text=annotation(fig,'textbox','String',['--'],'units','normalized', 'Position', [0.37 0.07 0.2 0.1],'EdgeColor','none');
% record_button.Callback = @(es,ed)recordButtonPushed(es,ed);

gain_slider.Callback = @(es,ed) update_gain(radio,es,gain_text);
freq_box.Callback= @(es,ed) update_freq(radio,es,freq_text);

results=zeros(ile_przebiegow_zapisac,probek_na_raz);
time_meas=zeros(ile_przebiegow_zapisac,probek_na_raz);
% global iteracja_zapis
iteracja_zapis=ile_przebiegow_zapisac+1;
while 1
    [x,no_samples,~,timestamps]=step(radio);
    % [x, metadata,timestamps] = capture(radio,probek_na_raz,'Samples');
    if no_samples<probek_na_raz
        warning('pobrano z USRP mniej probek')
    end
    gain=gain_slider.Value;%
    gain_text.String=['Gain (dB):' num2str(gain)];
    radio.Gain=gain;
    if record_button.Value==1
        iteracja_zapis=1;
        record_button.Value=0;
    end

    chwilowa=abs(fft(x(1:N))).^2;
    srednia=(1-alfa)*srednia+alfa*chwilowa;
    [~,integer_f_off]=max(srednia);
    integer_f_off=mod(integer_f_off-1+N/2,N)-N/2% w zakresie od -N/2 do N/2-1
    x_corr=transpose(x).*exp(-1j*2*pi*integer_f_off/N*[1:length(x)]);
    if iteracja_zapis<=size(results,1)
        disp(['Saved measurement ' num2str(iteracja_zapis) ' out of ' num2str(size(results,1))])
        record_text.String=[num2str(iteracja_zapis) '/' num2str(size(results,1))];
        results(iteracja_zapis,:)=transpose(x);
        time_meas(iteracja_zapis,:)=timestamps;
        if iteracja_zapis==size(results,1)
            save('probki.mat',"results",'time_meas')
            record_text.String='--';
        end
         iteracja_zapis=iteracja_zapis+1;
    end
    wykres_f.YData=fftshift(10*log10(srednia));
    wykres_t.YData=abs(x_corr(1:decymacja:end));
    % plot(freq+radio.CenterFrequency,fftshift(10*log10(srednia)));
    pause(0.1)
end

function update_gain(radio,new_gain,gain_text)
radio.Gain=round(new_gain.Value);
gain_text.String=['Gain (dB):' num2str(round(new_gain.Value))];
end
function update_freq(radio,new_freq,freq_text)
radio.CenterFrequency=str2double(new_freq.String);
freq_text.String=['Center. freq. (Hz):' new_freq.String];
end

  % frunction recordButtonPushed(es,ed)
  % global iteracja_zapis
         % iteracja_zapis=1;
    % end